include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext VVramBack_, VVramFront_, RowFlags_


; void ClearVVram();
cseg
ClearVVram_: public ClearVVram_
    push ax | push cx | push di
        mov ax,ds | mov es,ax
        mov di,VVramBack_
        xor ax,ax
        mov cx,VVramWidth*VVramHeight/2
        do
            stosw
        wloop
    pop di | pop cx | pop ax
ret


; word VVramOffset(byte x, byte y);
cseg
VVramOffset_: public VVramOffset_
    push dx
        mov dh,al
        mov al,VVramWidth
        mul dl
        mov dl,dh
        xor dh,dh
        add ax,dx
    pop dx
ret


; void VVramBackToFront();
cseg
VVramBackToFront_: public VVramBackToFront_
    push cx | push si | push di
        mov cx,ds | mov es,cx
        mov si,VVramBack_
        mov di,VVramFront_
        mov cx,VVramWidth*VVramHeight/2
        do
            movsw 
        wloop

        xor cx,cx
        mov [RowFlags_],cx
        mov [RowFlags_+2],cx
    pop di | pop si | pop cx
ret


; void SetRowFlags(byte y, byte b);
cseg
SetRowFlags_: public SetRowFlags_
    push ax | push bx | push cx | push dx
        xor dh,dh
        mov cl,al
        and cl,7
        shl dx,cl
        shr al,1 | shr al,1 | shr al,1
        xor ah,ah
        mov bx,RowFlags_
        add bx,ax
        or [bx],dx
    pop dx | pop cx | pop bx | pop ax
ret
